<script setup>
// imports
import ProductCategory from '@/components/products/ProductCategory.vue'
import ProductBrand from '@/components/products/ProductBrand.vue'
import ProductRating from '@/components/products/ProductRating.vue'
import DiscountBadge from '@/components/products/DiscountBadge.vue'
import { useSingleProductStore } from '@/core/stores/single_product'
import LoadingComponent from '@/components/base/LoadingComponent.vue'
import { useRoute } from 'vue-router'
import { ref } from 'vue'
import { useHead } from '@vueuse/head'

//data
const { params } = useRoute()
const singleProduct = useSingleProductStore()
await singleProduct.getSingleProduct(params.id)
const sliderOptions = ref({
  rewind: true,
  perPage: 1,
  pagination: false,
  gap: 15,
  speed: 800,
})

//head
useHead({
  title: 'Dolphino challenge | ' + singleProduct?.product?.title,
  meta: [
    {
      name: `description`,
      content: singleProduct?.product?.description
    },
    {
      name: 'keywords',
      content: 'shop,product,mobile,laptop,tablet'
    },
    {
      meta: 'og:title',
      content: 'Dolphino challenge | ' + singleProduct?.product?.title
    },
    {
      meta: 'og:site_name',
      content: 'Dolphino challenge'
    },
    {
      meta: 'url',
      content: 'https://test.com'
    },
    {
      meta: 'og:description',
      content: singleProduct?.product?.description
    },
    {
      meta: 'og:type',
      content: 'website'
    },
    {
      meta: 'og:image',
      contetn: 'https://address-of-site-logo.com'
    }
  ]
})
</script>

<template>
  <!--loading-->
  <LoadingComponent :loading="singleProduct.loading" />

  <div class="max-w-[600px] mx-auto lg:mt-32 flex flex-col gap-6">
    <!--top part-->
    <div>
      <h2 class="text-32 capitalize font-semibold">{{ singleProduct?.product?.title }}</h2>

      <div class="flex items-center gap-3">
        <ProductCategory :title="singleProduct?.product?.category" />
        <ProductBrand :title="singleProduct?.product?.brand" />
      </div>
    </div>

    <!--gallery-->
    <Splide :options="sliderOptions">
      <SplideSlide v-for="(img, index) in singleProduct?.product?.images" :key="index + 'img'">
        <div class="aspect-[16/9] overflow-hidden rounded-sm">
          <img
            :src="img"
            :alt="singleProduct?.product?.title"
            :title="singleProduct?.product?.title"
            class="w-full h-full object-cover"
          />
        </div>
      </SplideSlide>
    </Splide>

    <!--product details-->
    <div
      class="bg-background-secondary-light dark:bg-background-secondary-dark rounded-sm p-4 flex items-start justify-between gap-4"
    >
      <div>
        <DiscountBadge
          v-if="singleProduct?.product?.discountPercentage"
          :percentage="singleProduct?.product?.discountPercentage"
        />
        <div class="text-2xl">${{ singleProduct?.product?.price }}</div>
        <div
          class="flex items-center gap-1 text-text-secondary-light dark:text-text-secondary-dark text-xs mt-2"
        >
          <i class="flaticon-left-arrow rotate-180"></i>
          <div class="mt-1">There are {{ singleProduct?.product?.stock }} left</div>
        </div>
      </div>
      <ProductRating :rate="singleProduct?.product?.rating" />
    </div>

    <!--product description-->
    <p class="text-text-secondary-light dark:text-text-secondary-dark">
      {{ singleProduct?.product?.description }}
    </p>
  </div>
</template>
